package sdtext;

/**
 * Provides the different fingerprinters available within SDText (Similarity Digest Text)
 * 
 * @author Lindsay Neubauer
 * 
 */
enum FingerprinterEnum {

  /**
   * Creates a bit vector representing the presence or absence of terms in a particular dictionary
   */
  BitVectorFingerprinter("BitVectorFingerprinter");

  final String name;

  /**
   * Stores information about each fingerprinter
   * 
   * @param name
   *          the string name of the fingerprinter
   */
  FingerprinterEnum(String name) {
    this.name = name;
  }
}
