package sdtext;

import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;

/**
 * Listens to changes in a TableModel and resizes the width to accommodate added text to the table
 * 
 * @author Lindsay Neubauer
 */
public class UpdateTableSizeModelListener implements TableModelListener {
  private JTable table;
  private DefaultTableModel tableModel;
  private int incrementLength;

  UpdateTableSizeModelListener(JTable table, DefaultTableModel tableModel, int incrementLength) {
    this.table = table;
    this.tableModel = tableModel;
    this.incrementLength = incrementLength;
  }

  @Override
  public void tableChanged(TableModelEvent event) {
    TableColumnModel tableColumnModel = this.table.getColumnModel();
    int tokenLength = 100;
    int tableWidth = 0;
    if (this.tableModel.getDataVector().size() > 1) {
      tokenLength = this.incrementLength * this.tableModel.getDataVector().lastElement().toString().length();
      tableWidth = this.table.getColumn("").getWidth();
    }
    if (tokenLength > tableWidth) {
      tableColumnModel.getColumn(0).setMaxWidth(tokenLength);
      tableColumnModel.getColumn(0).setMinWidth(tokenLength);
      tableColumnModel.getColumn(0).setWidth(tokenLength);
      tableColumnModel.getColumn(0).setPreferredWidth(tokenLength);
    }
  }
}
